------------------------------------------------------------------------
-- Identity substitutions vanish
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import Implicit.SubstitutionLemmas.SimpleLemmas
-- # import EqKind
-- # import TmVar

abstract

  idLiftIsId⁻ (k : EqKind) (Γ : Ctxt)
    :  (tv : TmVar) -> (τ : Ty Γ)
    -> Subst⁻Eq k (id⁻ tv Γ ↑⁻ τ) (id⁻ tv (Γ ▻ τ))
  idLiftIsId⁻ tv₀ τ₀ =
    extEq⁻ˡ⁼ (id⁻ _ _ ↑⁻ _) (id⁻ _ _)
             (reflCtxt _ ▻Cong idVanishesTy τ₀)
             (\_ v -> proof tv₀ v)
    where
    proof (k : EqKind) (Γ : Ctxt) (τ : Ty Γ) (σ : Ty (Γ ▻ τ))
      :  (tv : TmVar) -> (v : Γ ▻ τ ∋ σ)
      -> Tm⁻Eq k (v /∋⁻ id⁻ tv Γ ↑⁻ τ) (v /∋⁻ id⁻ tv (Γ ▻ τ))
    proof tv (vz σ) =
      substVar⁻VzLift σ (id⁻ _ _)
        `transTm⁻`
      var⁻Cong (vzCong $ idVanishesTy σ)
        `transTm⁻`
      symTm⁻ (idVanishesVar⁻ (vz σ))
    proof tv (vs v σ) = coerceFromTm⁻ $
      substVar⁻VsLift v σ (id⁻ _ _) tv
        `transTm⁻`
      substTm⁻Congˢ (idVanishesVar⁻ v) (wk⁻Cong $ idVanishesTy σ)
        `transTm⁻`
      subst⁻Wk tv tv v σ
        `transTm⁻`
      symTm⁻ (idVanishesVar⁻ (vs v σ))
    proof tv (v ∷≡∋ eqτ') =
      betweenTm⁻ (substCastVar⁻ _ _ (id⁻ _ _ ↑⁻ _))
                 (substCastVar⁻ _ _ (id⁻ _ _)) $
        proof tv v

  idLiftʳIsId⁻ (k : EqKind) (Γ : Ctxt)
    :  (tv : TmVar) -> (Γ' : RCtxt Γ)
    -> Subst⁻Eq k (id⁻ tv Γ ↑⋆⁻ Γ') (id⁻ tv (Γ ++ Γ'))
  idLiftʳIsId⁻ tv (εʳ Γ) = coerceFromSubst⁻ $
    id⁻'Cong (weakCongˢ₁₂₁ _ _) (reflCtxt Γ)
  idLiftʳIsId⁻ tv (Γ' ▻ʳ τ) = coerceFromSubst⁻ $
    lift⁻'Cong (weakCongˢ₁₂₁ _ _)
               (idLiftʳIsId⁻ tv Γ') (reflTy τ)
      `transSubst⁻`
    idLiftIsId⁻ tv τ

  idVanishesVar⁻ʳ (k : EqKind) (Γ : Ctxt)
    :  (tv₁, tv₂ : TmVar) -> (Γ' : RCtxt Γ) -> (τ : Ty (Γ ++ Γ'))
    -> (v : Γ ++ Γ' ∋ τ)
    -> Tm⁻Eq k (v /∋⁻ id⁻ tv₁ Γ ↑⋆⁻ Γ') (var⁻ tv₂ v)
  idVanishesVar⁻ʳ tv₁ tv₂ Γ' _ v =
    substVar⁻Cong (reflVar v) (idLiftʳIsId⁻ tv₁ Γ')
      `transTm⁻`
    idVanishesVar⁻ v
      `transTm⁻`
    var⁻Cong (reflVar _)

  idVanishesTm⁻ʳ (k : EqKind) (tv₁ : TmVar) (Γ : Ctxt)
    :  (tv₂ : TmVar) -> (Γ' : RCtxt Γ) -> (τ : Ty (Γ ++ Γ'))
    -> (t : Γ ++ Γ' ⊢ τ) -> (t⁻ : Tm⁻ tv₁ t)
    -> Tm⁻Eq k (t⁻ /⊢⁻ id⁻ tv₂ Γ ↑⋆⁻ Γ') t⁻
  idVanishesTm⁻ʳ _ Γ' _ _ (var⁻ _ v) =
    Tm⁻⊔Eq _ _
      `transTm⁻`
    idVanishesVar⁻ʳ _ _ Γ' _ v
  idVanishesTm⁻ʳ _ Γ' _ _ (λ⁻ _ t) = castTm⁻Eqˡ _ $
    λ⁻Cong (idVanishesTm⁻ʳ _ (Γ' ▻ʳ _) _ _ t)
  idVanishesTm⁻ʳ _ Γ' _ _ (t₁ @⁻ t₂) = castTm⁻Eqˡ _ $
    app⁻Cong (idVanishesTm⁻ʳ _ Γ' _ _ t₁)
             (idVanishesTm⁻ʳ _ Γ' _ _ t₂)
  idVanishesTm⁻ʳ _ Γ' _ _ (t ∷≡⊢⁻ eqt) =
    castTm⁻Cong _ _ $ idVanishesTm⁻ʳ _ Γ' _ _ t

  idVanishesTm⁻ (k : EqKind) (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    : (tv : TmVar) -> (t⁻ : Tm⁻ tv t) -> Tm⁻Eq k (t⁻ /⊢⁻ id⁻ tv Γ) t⁻
  idVanishesTm⁻ tv t⁻ = idVanishesTm⁻ʳ tv (εʳ _) _ _ t⁻

Implicit-SubstitutionLemmas-IdVanishes : Type
Implicit-SubstitutionLemmas-IdVanishes =
  time-plugin(Implicit-SubstitutionLemmas-IdVanishes, Set)
