------------------------------------------------------------------------
-- More substitution lemmas
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import Implicit.SubstitutionLemmas.SimpleLemmas
-- # import Implicit.SubstitutionLemmas.IdVanishes
-- # import Implicit.SubstitutionLemmas.CompSplits
-- # import Implicit.SubstitutionLemmas.SubLemmas
-- # import Implicit.SubstitutionLemmas.BetaEtaCong
-- # import EqKind
-- # import TmVar

abstract

  emptyCtxtSubst⁻Is∅⁻
    (k : EqKind) (tv : TmVar) (Δ : Ctxt) (ρ : Subst ε Δ)
    : (ρ⁻ : Subst⁻ tv ρ) -> Subst⁻Eq k ρ⁻ (∅⁻ tv Δ)
  emptyCtxtSubst⁻Is∅⁻ {k} {tv} {Δ} ρ =
    extEq⁻ εCong (reflCtxt Δ) $ \_ v¹ _ v² eqv ->
      noVarInEmptyCtxt v¹

  substToSubst⁻∅ (k : EqKind) (Δ : Ctxt)
    :  (ρ : Subst ε Δ)
    -> Subst⁻Eq k (substToSubst⁻ ρ) (∅⁻ Term Δ)
  substToSubst⁻∅ ρ = emptyCtxtSubst⁻Is∅⁻ (substToSubst⁻ ρ)

  substToSubst⁻▷ (k : EqKind) (Γ, Δ : Ctxt) (τ : Ty Γ)
    :  (ρ : Subst (Γ ▻ τ) Δ)
    -> Subst⁻Eq k (substToSubst⁻ ρ)
                  (substToSubst⁻ (init ρ) ▷⁻ tmToTm⁻ (last ρ))
  substToSubst⁻▷ ρ₀ = extEq⁻⁼ _ _ (\_ v -> proof v ρ₀)
    where
    proof (k : EqKind) (Γ, Δ : Ctxt) (τ : Ty Γ) (σ : Ty (Γ ▻ τ))
      :  (v : Γ ▻ τ ∋ σ)
      -> (ρ : Subst (Γ ▻ τ) Δ)
      -> Tm⁻Eq k (v /∋⁻ substToSubst⁻ ρ)
                 (v /∋⁻ (substToSubst⁻ (init ρ) ▷⁻ tmToTm⁻ (last ρ)))
    proof (vz τ) ρ =
      castTm⁻Eqʳ _ $ castTm⁻Eqʳ _ $ symTm⁻ $ toTermEq _
    proof (vs v τ) ρ =
      symTm⁻ (toTermEq _)
        `transTm⁻`
      substTm⁻Cong (symTm⁻ (substVar⁻Wk Term v τ))
                   (reflSubst⁻ $ substToSubst⁻ ρ)
        `transTm⁻`
      symTm⁻ (compSplitsVar⁻ v (wk⁻ Term τ) (substToSubst⁻ ρ))
        `transTm⁻`
      symTm⁻ (castTm⁻Eq _ _)
    proof (v ∷≡∋ eqτ) ρ =
      betweenTm⁻ (substCastVar⁻ _ _ _) (substCastVar⁻ _ _ _) $
        proof v ρ

Implicit-SubstitutionLemmas-MoreLemmas : Type
Implicit-SubstitutionLemmas-MoreLemmas =
  time-plugin(Implicit-SubstitutionLemmas-MoreLemmas, Set)
