------------------------------------------------------------------------
-- Terms (indexed on terms with explicit substitutions)
------------------------------------------------------------------------

-- # import Explicit
-- # import TmVar

infixl 90 @⁻
infixl 45 ∷⊢⁻, ∷≡⊢⁻, ∷≛⊢⁻, ∷≛≡⊢⁻, ∷≡✶⁻

------------------------------------------------------------------------
-- Terms

mutual

  Tm⁻ (Γ : Ctxt) (τ : Ty Γ) : TmVar -> Γ ⊢ τ -> Set
  Tm⁻ = Tm⁻' _ _

  data Tm⁻' : (Γ : Ctxt) -> (τ : Ty Γ) -> TmVar -> Γ ⊢ τ -> Set where
    var⁻ (Γ : Ctxt) (τ : Ty Γ)
      : (tv : TmVar) -> (v : Γ ∋ τ) -> Tm⁻ tv (var v)
    λ⁻ (Γ : Ctxt) (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁)) (t : Γ ▻ τ₁ ⊢ τ₂)
       (tv : TmVar)
      : Ty⁻ τ₁ -> Tm⁻ tv t -> Tm⁻ Term (λ t)
    (@⁻) (Γ : Ctxt) (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
         (t₁ : Γ ⊢ Π τ₁ τ₂) (t₂ : Γ ⊢ τ₁) (tv₁, tv₂ : TmVar)
      : Tm⁻ tv₁ t₁ -> Tm⁻ tv₂ t₂ -> Tm⁻ Term (t₁ @ t₂)
    (∷≡⊢⁻) (Γ : Ctxt) (τ¹, τ² : Ty Γ) (t¹ : Γ ⊢ τ¹) (t² : Γ ⊢ τ²)
           (tv : TmVar)
      : Tm⁻ tv t¹ -> (eqt : t¹ ≈⊢ t²) -> Tm⁻ tv t²

  Ty⁻ (Γ : Ctxt) : Ty Γ -> Set
  Ty⁻ = Ty⁻' _

  data Ty⁻' : (Γ : Ctxt) -> Ty Γ -> Set where
    ✶⁻ : (Γ : Ctxt) -> Ty⁻ (✶ Γ)
    Π⁻ (Γ : Ctxt) (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
      : Ty⁻ τ₁ -> Ty⁻ τ₂ -> Ty⁻ (Π τ₁ τ₂)
    El⁻ (Γ : Ctxt) (t : Γ ⊢ ✶ Γ) (tv : TmVar)
      : Tm⁻ tv t -> Ty⁻ (El t)
    (∷≡✶⁻) (Γ : Ctxt) (τ¹, τ² : Ty Γ)
      : Ty⁻ τ¹ -> (eqτ : τ¹ ≛ τ²) -> Ty⁻ τ²

(∷≛≡⊢⁻) (Γ : Ctxt) (τ¹, τ² : Ty Γ) (t : Γ ⊢ τ¹) (tv : TmVar)
  : Tm⁻ tv t -> (eqτ : τ¹ ≛ τ²) -> Tm⁻ tv (t ∷≡⊢ eqτ)
t ∷≛≡⊢⁻ eqτ = t ∷≡⊢⁻ symTm (castTmEq _ eqτ)

------------------------------------------------------------------------
-- Converting Implicit terms to Explicit ones

tm⁻ToVar (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  : Tm⁻ Var t -> Γ ∋ τ
tm⁻ToVar (var⁻ _ v)   = v
tm⁻ToVar (t ∷≡⊢⁻ eqt) = tm⁻ToVar t ∷≡∋ tmEqTyEq eqt

abstract

  tm⁻ToVarEq (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    : (t⁻ : Tm⁻ Var t) -> var (tm⁻ToVar t⁻) ≈⊢ t
  tm⁻ToVarEq (var⁻ _ v)   = reflTm (var v)
  tm⁻ToVarEq (t ∷≡⊢⁻ eqt) =
    varCong (castVarEq _ _)
      `transTm`
    tm⁻ToVarEq t
      `transTm`
    eqt

mutual

  tm⁻ToTm (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
    : Tm⁻ tv t -> Γ ⊢ τ
  tm⁻ToTm (var⁻ _ v)   = var v
  tm⁻ToTm (λ⁻ _ t)     = λ (tm⁻ToTm t)
  tm⁻ToTm (t ∷≡⊢⁻ eqt) = tm⁻ToTm t ∷≡⊢ tmEqTyEq eqt
  tm⁻ToTm (t₁ @⁻ t₂)   =
    tm⁻ToTm t₁ @ tm⁻ToTm t₂ ∷≡⊢
    substTyCong (reflTy _) (subCong $ tm⁻ToTmEq t₂)

  tm⁻ToTmEq (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
    : (t⁻ : Tm⁻ tv t) -> tm⁻ToTm t⁻ ≈⊢ t
  tm⁻ToTmEq (var⁻ _ v)   = reflTm (var v)
  tm⁻ToTmEq (λ⁻ _ t)     = λCong (tm⁻ToTmEq t)
  tm⁻ToTmEq (t ∷≡⊢⁻ eqt) =
    castTmEqˡ (tmEqTyEq eqt) (tm⁻ToTmEq t)
      `transTm`
    eqt
  tm⁻ToTmEq (t₁ @⁻ t₂) =
    castTmEqˡ (substTyCong (reflTy _) (subCong (tm⁻ToTmEq t₂)))
              (appCong (tm⁻ToTmEq t₁) (tm⁻ToTmEq t₂))

mutual

  ty⁻ToTy (Γ : Ctxt) (τ : Ty Γ) : Ty⁻ τ -> Ty Γ
  ty⁻ToTy (✶⁻ Γ)                     = ✶ Γ
  ty⁻ToTy (El⁻ t⁻)                   = El (tm⁻ToTm t⁻)
  ty⁻ToTy (τ⁻ ∷≡✶⁻ eqτ)              = ty⁻ToTy τ⁻
  ty⁻ToTy {Γ} {Π τ₁ τ₂} (Π⁻ τ⁻₁ τ⁻₂) =
    Π (ty⁻ToTy τ⁻₁) (ty⁻ToTy τ⁻₂ ∷✶ lemma)
    where
    abstract
      lemma : Γ ▻ τ₁ ≜ Γ ▻ ty⁻ToTy τ⁻₁
      lemma = reflCtxt _ ▻Cong symTy (ty⁻ToTyEq τ⁻₁)

  ty⁻ToTyEq (Γ : Ctxt) (τ : Ty Γ)
    : (τ⁻ : Ty⁻ τ) -> ty⁻ToTy τ⁻ ≛ τ
  ty⁻ToTyEq (✶⁻ Γ)        = reflTy (✶ Γ)
  ty⁻ToTyEq (El⁻ t⁻)      = ElCong (tm⁻ToTmEq t⁻)
  ty⁻ToTyEq (τ⁻ ∷≡✶⁻ eqτ) = ty⁻ToTyEq τ⁻ `transTy` eqτ
  ty⁻ToTyEq (Π⁻ τ⁻₁ τ⁻₂)  =
    ΠCong (ty⁻ToTyEq τ⁻₁) (castTyEqˡ _ $ ty⁻ToTyEq τ⁻₂)

------------------------------------------------------------------------
-- Term casts

mutual

  castTy⁻Ctxt (Γ¹ : Ctxt) (τ : Ty Γ¹)
              (Γ² : Ctxt)
    : Ty⁻ τ -> (eqΓ : Γ¹ ≜ Γ²) -> Ty⁻ (τ ∷✶ eqΓ)
  castTy⁻Ctxt (✶⁻ _)                     eqΓ = ✶⁻ _
  castTy⁻Ctxt (Π⁻ {_} {τ₁} {τ₂} τ⁻₁ τ⁻₂) eqΓ =
    Π⁻ (castTy⁻Ctxt τ⁻₁ eqΓ)
       (castTy⁻Ctxt τ⁻₂ (eqΓ ▻Cong castTyEq τ₁ eqΓ) ∷≡✶⁻ lemma)
    where
    abstract
      lemma : τ₂ / generalisedId (eqΓ ▻Cong castTyEq τ₁ eqΓ) ≛
              τ₂ / generalisedId eqΓ ↑ τ₁
      lemma =
        substTyCong (reflTy τ₂)
                    (generalisedIdIsId (eqΓ ▻Cong castTyEq τ₁ eqΓ)
                       `transSubst`
                     symSubst (idLiftIsId τ₁)
                       `transSubst`
                     liftCong (symSubst $ generalisedIdIsId eqΓ)
                              (reflTy τ₁))
  castTy⁻Ctxt (El⁻ {Γ} {t} t⁻) eqΓ =
    El⁻ (castTm⁻Ctxt t⁻ eqΓ ∷≡⊢⁻ lemma)
    where
    abstract
      lemma : t ∷⊢ castTyEq (✶ Γ) eqΓ ≈⊢ t /⊢ generalisedId eqΓ
      lemma =
        symTm (generalCastTmEq t _)
          `transTm`
        symTm (generalisedIdVanishesTm t eqΓ)
  castTy⁻Ctxt (τ⁻ ∷≡✶⁻ eqτ) eqΓ =
    castTy⁻Ctxt τ⁻ eqΓ ∷≡✶⁻ substTyCong eqτ (reflSubst _)

  castTm⁻Ctxt (Γ¹ : Ctxt) (τ : Ty Γ¹) (t : Γ¹ ⊢ τ) (tv : TmVar)
              (Γ² : Ctxt)
    : Tm⁻ tv t -> (eqΓ : Γ¹ ≜ Γ²) -> Tm⁻ tv (t ∷⊢ castTyEq τ eqΓ)
  castTm⁻Ctxt {Γ¹} {τ} (var⁻ tv v) eqΓ =
    var⁻ tv (castVarCtxt v eqΓ) ∷≡⊢⁻ lemma
    where
    abstract
      lemma : var (castVarCtxt v eqΓ) ≈⊢ var v ∷⊢ castTyEq τ eqΓ
      lemma =
        varCong (symVar $ castVarCtxtEq v eqΓ)
          `transTm`
        generalCastTmEq _ _
  castTm⁻Ctxt (λ⁻ {_} {τ₁} {τ₂} {t} τ⁻₁ t⁻) eqΓ =
    λ⁻ (castTy⁻Ctxt τ⁻₁ eqΓ) (castTm⁻Ctxt t⁻ eqΓτ) ∷≡⊢⁻ lemma
    where
    eqΓτ = eqΓ ▻Cong castTyEq τ₁ eqΓ
    abstract
      lemma : λ (t ∷⊢ castTyEq τ₂ eqΓτ) ≈⊢ λ t ∷⊢ castTyEq (Π τ₁ τ₂) eqΓ
      lemma =
        λCong (symTm $ generalCastTmEq _ _)
          `transTm`
        generalCastTmEq _ _
  castTm⁻Ctxt ((@⁻) {_} {τ₁} {τ₂} {t₁} {t₂} t⁻₁ t⁻₂) eqΓ =
    castTm⁻Ctxt t⁻₁ eqΓ @⁻ castTm⁻Ctxt t⁻₂ eqΓ ∷≡⊢⁻ lemma
    where
    abstract
      lemma : (t₁ ∷⊢ castTyEq (Π τ₁ τ₂) eqΓ) @ (t₂ ∷⊢ castTyEq τ₁ eqΓ)
              ≈⊢
              t₁ @ t₂ ∷⊢ castTyEq (τ₂ / sub t₂) eqΓ
      lemma =
        appCong (symTm $ generalCastTmEq _ _)
                (symTm $ generalCastTmEq _ _)
          `transTm`
        generalCastTmEq _ _
  castTm⁻Ctxt ((∷≡⊢⁻) {_} {τ¹} {τ²} {t¹} {t²} t⁻ eqt) eqΓ =
    castTm⁻Ctxt t⁻ eqΓ ∷≡⊢⁻ lemma
    where
    abstract
      lemma : t¹ ∷⊢ castTyEq τ¹ eqΓ ≈⊢ t² ∷⊢ castTyEq τ² eqΓ
      lemma = generalCastTmCong _ _ eqt

(∷⊢⁻) (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
      (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
      (tv : TmVar)
  : Tm⁻ tv t¹ -> t¹ ≈⊢ t² -> Tm⁻ tv t²
(∷⊢⁻) {Γ¹} {τ¹} {t¹} {Γ²} {τ²} {t²} t⁻ eqt =
  castTm⁻Ctxt t⁻ eqΓ ∷≡⊢⁻ lemma
  where
  abstract
    eqΓ : Γ¹ ≜ Γ²
    eqΓ = tmEqCtxtEq eqt

    lemma : t¹ ∷⊢ castTyEq τ¹ eqΓ ≈⊢ t²
    lemma =
      symTm (generalCastTmEq _ _)
        `transTm`
      eqt

(∷≛⊢⁻) (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t : Γ¹ ⊢ τ¹)
       (Γ² : Ctxt) (τ² : Ty Γ²)
       (tv : TmVar)
  : Tm⁻ tv t -> (eqτ : τ¹ ≛ τ²) -> Tm⁻ tv (t ∷⊢ eqτ)
(∷≛⊢⁻) {_} {_} {t} t⁻ eqτ = t⁻ ∷⊢⁻ lemma
  where
  abstract
    lemma : t ≈⊢ t ∷⊢ eqτ
    lemma = generalCastTmEq _ eqτ

castTm⁻TmVar (tv¹, tv² : TmVar) (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  : tv¹ ≡ tv² -> Tm⁻ tv¹ t -> Tm⁻ tv² t
castTm⁻TmVar refl th = th

------------------------------------------------------------------------
-- Converting Var terms to Term terms

toTerm (tv : TmVar) (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  : Tm⁻ tv t -> Tm⁻ Term t
toTerm                  (var⁻ tv v)   = var⁻ Term v
toTerm                  (t⁻ ∷≡⊢⁻ eqt) = toTerm t⁻ ∷≡⊢⁻ eqt
toTerm {Term' Var refl} t⁻            = t⁻

fromVar (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  : (tv : TmVar) -> Tm⁻ Var t -> Tm⁻ tv t
fromVar Var              t⁻ = t⁻
fromVar (Term' Var refl) t⁻ = toTerm t⁻

Tm⁻⊔ (tv₂ : TmVar) (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  : (tv₁ : TmVar) -> Tm⁻ tv₂ t -> Tm⁻ (tv₁ ⊔ tv₂) t
Tm⁻⊔ Var              t⁻ = t⁻
Tm⁻⊔ (Term' Var refl) t⁻ = toTerm t⁻

Implicit-Terms : Type
Implicit-Terms = time-plugin(Implicit-Terms, Set)
