------------------------------------------------------------------------
-- Evaluation
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit
-- # import Normalisation.NormalForms
-- # import Normalisation.Values
-- # import Normalisation.Environments
-- # import TmVar

-- The ˢ index stands for "_s_emantical value".

infixl 70 /⊢⁻ˢ

------------------------------------------------------------------------
-- Substitution application (evaluation)

(/⊢⁻ˢ) (Γ, Δ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (ρ : Subst Γ Δ) (tv : TmVar)
  : (t⁻ : Tm⁻ tv t) -> (ρˢ : Substˢ ρ) -> Val (t /⊢ ρ)
var⁻ _ v      /⊢⁻ˢ ρ = v /∋ˢ ρ
(t⁻₁ @⁻ t⁻₂)  /⊢⁻ˢ ρ = (t⁻₁ /⊢⁻ˢ ρ) @ˢ (t⁻₂ /⊢⁻ˢ ρ)
                       ∷ˢ symTm (substApp _ _ _)
(t⁻ ∷≡⊢⁻ eqt) /⊢⁻ˢ ρ = t⁻ /⊢⁻ˢ ρ ∷ˢ substTmCong eqt (reflSubst _)
(/⊢⁻ˢ) {Γ} {Δ} {Π τ₁ τ₂} {λ t₁} {ρ} (λ⁻ _ t⁻₁) ρˢ = ΠVal $ \Δ' t₂ v₂ ->
  t⁻₁ /⊢⁻ˢ (wk⇒ˢ⋆ ρˢ Δ' ▷ˢ (v₂ ∷≛ˢ lemma₁ Δ'))
  ∷ˢ lemma₂ Δ' t₂
  where
  abstract
    lemma₁ : (Δ' : RCtxt Δ) -> τ₁ / ρ / wk⋆ Δ' ≛ τ₁ / wk⇒⋆ ρ Δ'
    lemma₁ Δ' =
      symTy (compSplitsTy _ _ _)
        `transTy`
      substTyCong (reflTy τ₁) (symSubst $ wk⇒⋆IsCompWk⋆ ρ Δ')

    lemma₂
      :  (Δ' : RCtxt Δ)
      -> (t₂ : Δ ++ Δ' ⊢ τ₁ / ρ / wk⋆ Δ')
      -> t₁ /⊢ (wk⇒⋆ ρ Δ' ▷ (t₂ ∷⊢ lemma₁ Δ')) ≈⊢
         (λ t₁ /⊢ ρ /⊢ wk⋆ Δ') @ t₂
    lemma₂ Δ' t₂ =
      compSplitsTm t₁ (wk⇒⋆ ρ Δ' ↑ τ₁) (sub $ t₂ ∷⊢ lemma₁ Δ')
        `transTm`
      symTm (β (t₁ /⊢ wk⇒⋆ ρ Δ' ↑ τ₁) (t₂ ∷⊢ lemma₁ Δ'))
        `transTm`
      appCong (symTm (substλ t₁ (wk⇒⋆ ρ Δ'))
                 `transTm`
               substTmCong (reflTm $ λ t₁) (wk⇒⋆IsCompWk⋆ ρ Δ')
                 `transTm`
               compSplitsTm (λ t₁) ρ (wk⋆ Δ'))
              (symTm $ generalCastTmEq _ _)

tm⁻ToVal (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
  : (t⁻ : Tm⁻ tv t) -> Val t
tm⁻ToVal {Γ} t⁻ = t⁻ /⊢⁻ˢ idˢ Γ ∷ˢ idVanishesTm _

eval (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
  : (t⁻ : Tm⁻ tv t) -> NF t
eval t⁻ = reify (tm⁻ToVal t⁻)

normalise⁻ (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
  : Tm⁻ tv t -> Tm⁻ Term t
normalise⁻ t⁻ = nfToTm⁻ $ eval t⁻

abstract

  normalise⁻Eq (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (tv : TmVar)
    : (t⁻ : Tm⁻ tv t) -> normalise⁻ t⁻ ≈⊢⁻ t⁻
  normalise⁻Eq {_} {_} {t} t⁻ = tmEqTm⁻Eq $ reflTm t

  normalise⁻Cong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
                 (tv¹ : TmVar) (t⁻¹ : Tm⁻ tv¹ t¹)
                 (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
                 (tv² : TmVar) (t⁻² : Tm⁻ tv² t²)
    : t⁻¹ ≈⊢⁻ t⁻² -> normalise⁻ t⁻¹ ≈⊢⁻ normalise⁻ t⁻²
  normalise⁻Cong eqt⁻ = tmEqTm⁻Eq $ tm⁻EqTmEq eqt⁻

normalise (Γ : Ctxt) (τ : Ty Γ) : Γ ⊢ τ -> Γ ⊢ τ
normalise t = tm⁻ToTm (normalise⁻ $ tmToTm⁻ t)

abstract

  normaliseEq (Γ : Ctxt) (τ : Ty Γ)
    : (t : Γ ⊢ τ) -> normalise t ≈⊢ t
  normaliseEq t = tm⁻ToTmEq (normalise⁻ $ tmToTm⁻ t)

  normaliseCong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
                (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
    : t¹ ≈⊢ t² -> normalise t¹ ≈⊢ normalise t²
  normaliseCong eqt = tm⁻ToTmCong $ normalise⁻Cong $ tmToTm⁻Cong eqt

Normalisation-Evaluation : Type
Normalisation-Evaluation = time-plugin(Normalisation-Evaluation, Set)
